VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cAPI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function NetGetDCName _
   Lib "Netapi32.dll" _
   (servername As Byte, _
    DomainName As Byte, _
    Buffer As Long) As Long
Private Declare Function GetComputerName _
   Lib "kernel32" Alias "GetComputerNameA" _
   (ByVal lpBuffer As String, _
    nSize As Long) As Long
Private Declare Function NetWkstaGetInfo _
   Lib "netapi32" _
   (ByVal servername As Long, _
    ByVal level As Long, _
    bufptr As Long) As Long
Private Declare Function StrLenW _
   Lib "kernel32" Alias "lstrlenW" _
   (ByVal Ptr As Long) As Long
Private Declare Sub CopyMem _
   Lib "kernel32" Alias "RtlMoveMemory" _
   (pTo As Any, _
    uFrom As Any, _
    ByVal lSize As Long)
Private Declare Function NetServerEnum _
   Lib "netapi32" _
   (ByVal sServerName As Long, _
    ByVal lLevel As Long, _
    vBuffer As Long, _
    ByVal lPreferedMaxLen As Long, _
    lEntriesRead As Long, _
    lTotalEntries As Long, _
    ByVal vServerType As Long, _
    ByVal sDomain As Long, _
    vResume As Long) As Long
Private Declare Function NetApiBufferFree _
   Lib "netapi32" _
   (ByVal lBuffer&) As Long
Private Declare Sub lstrcpyW _
   Lib "kernel32" _
   (vDest As Any, _
    ByVal vSrc As Any)

Private Type WKSTA_INFO_102
   wki102_platform_id As Long
   wki102_computername As Long
   wki102_langroup As Long
   wki102_ver_major As Long
   wki102_ver_minor As Long
   wki102_lanroot As Long
   wki102_logged_on_users As Long
End Type

Private Type SERVER_INFO_101
   sv101_platform_id                   As Long
   sv101_servername                    As Long
   sv101_version_major                 As Long
   sv101_version_minor                 As Long
   sv101_type                          As Long
   sv101_comment                       As Long
End Type
      
' Constants for type of computer
Private Const SV_TYPE_WORKSTATION      As Long = &H1&
Private Const SV_TYPE_SERVER           As Long = &H2&
Private Const SV_TYPE_DOMAIN_CTRL      As Long = &H8&
Private Const SV_TYPE_DOMAIN_BAKCTRL   As Long = &H10&
Private Const SV_TYPE_NT               As Long = &H1000&
Private Const SV_TYPE_SERVER_NT        As Long = &H8000&
Private Const SV_TYPE_WINDOWS          As Long = &H400000
Private Const SV_TYPE_ALL              As Long = &HFFFF

Private Const MAX_COMPUTERNAME         As Long = 15
Private Const NERR_SUCCESS             As Long = 0&

Private Const PLATFORM_ID_DOS          As Long = 300
Private Const PLATFORM_ID_OS2          As Long = 400
Private Const PLATFORM_ID_NT           As Long = 500
Private Const PLATFORM_ID_OSF          As Long = 600
Private Const PLATFORM_ID_VMS          As Long = 700

Public Function GetWorkstationInfo(ByVal xi_strComputerName As String) As Variant
   Dim p_lngBufferPtr                  As Long
   Dim p_lngRtn                        As Long
   Dim p_lngStructSize                 As Long
   Dim p_typWrkStaInfo102              As WKSTA_INFO_102
   Dim p_avntRtn(1 To 6)               As Variant
   
   p_lngRtn = NetWkstaGetInfo(StrPtr(xi_strComputerName), _
                              102, _
                              p_lngBufferPtr)
   If p_lngRtn <> NERR_SUCCESS Then
      ' Had error
   Else
      p_lngStructSize = LenB(p_typWrkStaInfo102)
      CopyMem p_typWrkStaInfo102, _
              ByVal p_lngBufferPtr, _
              p_lngStructSize
              
      p_avntRtn(1) = p_typWrkStaInfo102.wki102_platform_id
      p_avntRtn(2) = p_typWrkStaInfo102.wki102_ver_major
      p_avntRtn(3) = p_typWrkStaInfo102.wki102_ver_minor
      p_avntRtn(4) = p_typWrkStaInfo102.wki102_logged_on_users
      If p_typWrkStaInfo102.wki102_platform_id = PLATFORM_ID_NT Then
         p_avntRtn(5) = "NT Platform"
      ElseIf p_typWrkStaInfo102.wki102_platform_id = PLATFORM_ID_DOS Then
         p_avntRtn(5) = "Win9x Platform"
      Else
         p_avntRtn(5) = "Unknown Platform"
      End If
      p_avntRtn(6) = PointerToUnicodeStr(p_typWrkStaInfo102.wki102_langroup)
      GetWorkstationInfo = p_avntRtn
   End If

End Function

Public Function GetLocalMachineName() As String
   Dim p_strTmp                        As String
   Dim p_lngRtn                        As Long
   Dim p_lngLen                        As Long
   
   p_strTmp = Space$(MAX_COMPUTERNAME + 1)
   p_lngLen = Len(p_strTmp)
   
   p_lngRtn = GetComputerName(p_strTmp, p_lngLen)
   If p_lngRtn <> 0 Then
      GetLocalMachineName = Mid$(p_strTmp, 1, p_lngLen)
   End If

End Function

Public Function GetDC(ByVal xi_strDomainName As String) As String
   Dim p_abytServerName()              As Byte
   Dim p_abytDomainName()              As Byte
   Dim p_lngRtn                        As Long
   Dim p_lngBufferPtr                  As Long
   Dim p_strDCName                     As String
   Dim p_strDomainName                 As String
   
   ' ------------------------------------------
   ' Move to byte array
   ' ------------------------------------------
   p_abytServerName = vbNullChar
   p_abytDomainName = xi_strDomainName & vbNullChar
            
   ' ------------------------------------------
   ' Get the name of the PDC
   ' ------------------------------------------
   p_lngRtn = NetGetDCName(p_abytServerName(0), _
                           p_abytDomainName(0), _
                           p_lngBufferPtr)

   If p_lngRtn = 0 Then
      p_strDCName = PointerToUnicodeStr(p_lngBufferPtr)
      
      If Left$(p_strDCName, 2) = "\\" Then
         p_strDCName = Mid$(p_strDCName, 3)
      End If
   
      p_strDomainName = p_abytDomainName
      
   Else
      p_strDCName = ""
   End If

   GetDC = p_strDCName
   
End Function

Public Function GetServers() As Variant
   Dim p_strServerName                 As String
   Dim p_strComputerName               As String
   Dim p_strComment                    As String
   Dim p_lngRtn                        As Long
   Dim p_lngSvrInfoRtn                 As Long
   Dim p_lngPreferedMaxLen             As Long
   Dim p_lngNumEntriesRead             As Long
   Dim p_lngTotalEntries               As Long
   Dim p_lngServerType                 As Long
   Dim p_lngResume                     As Long
   Dim p_lngCount                      As Long
   Dim p_lngPtrServerInfo101           As Long
   Dim p_lngServerEnumLevel            As Long
   Dim p_lngPos                        As Long
   Dim p_typServerInfo101              As SERVER_INFO_101
   Dim p_abytBuffer(512)               As Byte
   Dim p_avntComputers()               As Variant
   
   ' Initialize the variables
   p_lngServerEnumLevel = 101
   p_lngPreferedMaxLen = -1
   p_lngServerType = SV_TYPE_NT
  
   ' Call NetServerEnum to get a list of Servers
   p_lngRtn = NetServerEnum(0&, _
                            p_lngServerEnumLevel, _
                            p_lngSvrInfoRtn, _
                            p_lngPreferedMaxLen, _
                            p_lngNumEntriesRead, _
                            p_lngTotalEntries, _
                            p_lngServerType, _
                            0&, _
                            p_lngResume)
   
   ' NetServerEnum Index is 1 based -- iterate
   '     thru the return values to get the
   '     NT servers and workstations
   p_lngCount = 1
   p_lngPtrServerInfo101 = p_lngSvrInfoRtn
           
   If p_lngTotalEntries <= 0 Then
      If p_lngSvrInfoRtn <> 0 Then
         p_lngRtn = NetApiBufferFree(p_lngSvrInfoRtn)
      End If
      Exit Function
   End If
   
   ReDim p_avntComputers(0 To p_lngTotalEntries - 1, 1 To 2)
   
   For p_lngCount = 1 To p_lngTotalEntries
      p_strComputerName = ""
           
      CopyMem p_typServerInfo101, _
              ByVal p_lngPtrServerInfo101, _
              Len(p_typServerInfo101)
   
      On Error Resume Next
      p_strComment = vbNullString
      p_strComputerName = PointerToUnicodeStr(p_typServerInfo101.sv101_servername)
      p_strComment = PointerToUnicodeStr(p_typServerInfo101.sv101_comment)
      
      p_lngPos = InStr(p_strComputerName, vbNullChar)
      If p_lngPos > 0 Then
         p_strComputerName = Mid$(p_strComputerName, 1, p_lngPos - 1)
      End If
      
      p_lngPos = InStr(p_strComment, vbNullChar)
      If p_lngPos > 0 Then
         p_strComment = Mid$(p_strComment, 1, p_lngPos - 1)
      End If
      
      p_avntComputers(p_lngCount - 1, 1) = p_strComputerName
      p_avntComputers(p_lngCount - 1, 2) = p_strComment
      
      p_lngPtrServerInfo101 = p_lngPtrServerInfo101 + Len(p_typServerInfo101)
   
   Next p_lngCount
   
   p_lngRtn = NetApiBufferFree(p_lngSvrInfoRtn)
   GetServers = p_avntComputers

End Function

Private Function PointerToUnicodeStr(ByVal xi_lngPtrToString As Long) As String
On Error Resume Next                   ' Don't accept an error here
   Dim p_abytBuffer()                  As Byte
   Dim p_lngLen                        As Long
   Dim p_strTmp                        As String
   Dim p_lngRtn                        As Long
   
   ' ------------------------------------------
   ' Get the length of the string from the pointer
   ' ------------------------------------------
   p_lngLen = StrLenW(xi_lngPtrToString) * 2
   
   ' ------------------------------------------
   ' Now convert to a string
   ' ------------------------------------------
   If (xi_lngPtrToString <> 0) And (p_lngLen > 0) Then
      ReDim p_abytBuffer(0 To (p_lngLen - 1)) As Byte
      CopyMem p_abytBuffer(0), ByVal xi_lngPtrToString, p_lngLen
      p_strTmp = p_abytBuffer
   End If
   
   ' ------------------------------------------
   ' Set the return value
   ' ------------------------------------------
   PointerToUnicodeStr = p_strTmp
   
End Function


