VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cWmiInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const HKLM                     As Long = &H80000002

Private Function GetOS(ByVal xi_sWbemServices As SWbemServices) As Variant
   Dim vntTmp                          As Variant
   Dim vntRtn                          As Variant
   
   ReDim vntRtn(1 To 2) As Variant
   
   vntTmp = GetOsData(xi_sWbemServices)
   If Left$(vntTmp(1, 13), 4) = "5.0." Then
      If CLng(vntTmp(1, 25)) >= 3 Then
         vntRtn(1) = True
         vntRtn(2) = vbNullString
      Else
         vntRtn(1) = False
         vntRtn(2) = "If you are running W2K, you must have at least SP3 to run this method. You are running SP " & vntTmp(1, 25)
      End If
   Else
      vntRtn(1) = True
      vntRtn(2) = vbNullString
   End If
   
   
   GetOS = vntRtn
   
End Function

Public Function GetHotFixData2(ByVal xi_sWbemServices As SWbemServices, _
                             ByRef xo_vntColHeadings As Variant, _
                             ByVal xi_strComputer As String) As Variant
On Error Resume Next
   Const BASE_KEY                      As String = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Hotfix\"
   Dim strComments                     As String
   Dim strFixDesc                      As String
   Dim strInstallDate                  As String
   Dim lngIsInstalled                  As Long
   Dim lngServicePack                  As Long
   Dim strTmp                          As String
   Dim lngRtn                          As Long
   Dim astrSubKeys                     As Variant
   Dim strKey                          As Variant
   Dim vntTmp                          As Variant
   Dim objRegistry                     As SWbemObjectEx
   Dim lngIndex                        As Long
   Dim vntRtnData                      As Variant
   
   If Trim$(xi_strComputer) = vbNullString Then
      xi_strComputer = "."
   End If
   
   Set objRegistry = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & xi_strComputer & "/root/default:StdRegProv")
   
   lngRtn = objRegistry.EnumKey(HKLM, BASE_KEY, astrSubKeys)
   
   ReDim vntRtnData(1 To UBound(astrSubKeys) + 1) As Variant
   
   ReDim xo_vntColHeadings(1 To 4) As String
   xo_vntColHeadings(1) = "Display Name"
   xo_vntColHeadings(2) = "Comments"
   xo_vntColHeadings(3) = "Install Date"
   xo_vntColHeadings(4) = "SP Number"
   'xo_vntColHeadings(5) = "Fix Description"
   
   lngIndex = 0
   For Each strKey In astrSubKeys
      ReDim vntTmp(1 To 4) As String
      
      strComments = vbNullString
      strFixDesc = vbNullString
      strInstallDate = vbNullString
      lngIsInstalled = 0
      lngServicePack = 0
      
      ' ---------------------------------------
      ' Get the display name
      ' ---------------------------------------
      vntTmp(1) = strKey
      
      ' ---------------------------------------
      ' Get the Comments
      ' ---------------------------------------
      lngRtn = objRegistry.GetStringValue(HKLM, _
                                          BASE_KEY & strKey, _
                                          "Comments", _
                                          strComments)
      vntTmp(2) = strComments

      ' ---------------------------------------
      ' Get the Installation date
      ' ---------------------------------------
      lngRtn = objRegistry.GetStringValue(HKLM, _
                                          BASE_KEY & strKey, _
                                          "Installed On", _
                                          strFixDesc)
      vntTmp(3) = strFixDesc
      
      ' ---------------------------------------
      ' Get the "Is Installed" value
      ' ---------------------------------------
      lngRtn = objRegistry.GetDWORDValue(HKLM, _
                                         BASE_KEY & strKey, _
                                         "Installed", _
                                         lngIsInstalled)

      ' ---------------------------------------
      ' Get the Service Pack value
      ' ---------------------------------------
      lngRtn = objRegistry.GetDWORDValue(HKLM, _
                                         BASE_KEY & strKey, _
                                         "Service Pack", _
                                         lngServicePack)
      vntTmp(4) = lngServicePack
      
      ' ---------------------------------------
      ' Set the array value
      ' ---------------------------------------
      If lngIsInstalled <> 0 Then
         lngIndex = lngIndex + 1
         vntRtnData(lngIndex) = vntTmp
      Else
         ' Don't add
         Debug.Print
      End If
      
   Next
   
   GetHotFixData2 = vntRtnData
   
End Function
                             
Public Function GetHotFixData(ByVal xi_sWbemServices As SWbemServices, _
                            ByRef xo_vntColHeadings As Variant) As Variant
On Error Resume Next
   Dim vntTmp                          As Variant
   Dim objInstalledQuickFixes          As SWbemObjectSet
   Dim objInstallQFix                  As SWbemObject
   Dim objProperty                     As SWbemProperty
   Dim lngIndex                        As Long
   Dim vntRtnData                      As Variant
   
   vntTmp = GetOS(xi_sWbemServices)
   If vntTmp(1) = False Then
      MsgBox vntTmp(2)
      Exit Function
   End If
      
   Set objInstalledQuickFixes = xi_sWbemServices.InstancesOf("Win32_QuickFixEngineering")
   
   ReDim vntRtnData(1 To objInstalledQuickFixes.Count) As Variant
   
   ReDim xo_vntColHeadings(1 To 6) As String
   xo_vntColHeadings(1) = "Hot Fix ID"
   xo_vntColHeadings(2) = "Installed By"
   xo_vntColHeadings(3) = "Install Date"
   xo_vntColHeadings(4) = "SP Installed"
   xo_vntColHeadings(5) = "Comment"
   xo_vntColHeadings(6) = "Description"

   For Each objInstallQFix In objInstalledQuickFixes
      ReDim vntTmp(1 To 6) As String
      
      For Each objProperty In objInstallQFix.Properties_
         With objProperty
            Select Case objProperty.Name
               Case "HotFixID"
                  vntTmp(1) = .Value
               Case "InstalledBy"
                  vntTmp(2) = .Value
               Case "InstallDate"
                  vntTmp(3) = TransSoftwareDate(.Value)
               Case "ServicePackInEffect"
                  vntTmp(4) = .Value
               Case "FixComments"
                  vntTmp(5) = .Value
               Case "Description"
                  vntTmp(6) = .Value
               Case Else
                  ' Ignore the rest
                  'Debug.Print .Name, .Value
            End Select
         End With
         
      Next
         
      If Len(Trim$(vntTmp(1, 0))) > 0 Then
         lngIndex = lngIndex + 1
         vntRtnData(lngIndex) = vntTmp
      End If
         
   Next

   GetHotFixData = vntRtnData

End Function

Public Function GetInstalledSoftwareData2(ByVal xi_sWbemServices As SWbemServices, _
                                          ByRef xo_vntColHeadings As Variant, _
                                          ByVal xi_strComputer As String) As Variant
On Error Resume Next
   Const BASE_KEY                      As String = "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\"
   Dim strDisplayName                  As String
   Dim strDisplayVersion               As String
   Dim strInstallLocation              As String
   Dim strDisplayVersionMajor          As String
   Dim strDisplayVersionMinor          As String
   Dim strInstallDate                  As String
   Dim strInstallFrom                  As String
   Dim strTmp                          As String
   Dim objRegistry                     As SWbemObjectEx
   Dim lngRtn                          As Long
   Dim astrSubKeys                     As Variant
   Dim strKey                          As Variant
   Dim vntTmp                          As Variant
   Dim lngIndex                        As Long
   Dim vntRtnData                      As Variant
   
   If Trim$(xi_strComputer) = vbNullString Then
      xi_strComputer = "."
   End If
   
   Set objRegistry = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & xi_strComputer & "/root/default:StdRegProv")
   
   lngRtn = objRegistry.EnumKey(HKLM, BASE_KEY, astrSubKeys)
   
   ReDim vntRtnData(1 To UBound(astrSubKeys) + 1) As Variant
   
   ReDim xo_vntColHeadings(1 To 5) As String
   xo_vntColHeadings(1) = "Display Name"
   xo_vntColHeadings(2) = "Version"
   xo_vntColHeadings(3) = "Install To"
   xo_vntColHeadings(4) = "Install Date"
   xo_vntColHeadings(5) = "Install From"
   
   lngIndex = 0
   For Each strKey In astrSubKeys
      ReDim vntTmp(1 To 5) As String
      
      strDisplayName = vbNullString
      strDisplayVersion = vbNullString
      strInstallLocation = vbNullString
      strDisplayVersionMajor = vbNullString
      strDisplayVersionMinor = vbNullString
      strInstallDate = vbNullString
      strInstallFrom = vbNullString
      
      ' ---------------------------------------
      ' Get the display name
      ' ---------------------------------------
      lngRtn = objRegistry.GetStringValue(HKLM, _
                                          BASE_KEY & strKey, _
                                          "DisplayName", _
                                          strDisplayName)
      
      ' If blank, try "Quiet Name
      If Trim$(strDisplayName) = vbNullString Then
         lngRtn = objRegistry.GetStringValue(HKLM, _
                                             BASE_KEY & strKey, _
                                             "QuietDisplayName", _
                                             strDisplayName)
      End If
   
      ' If other 2 fail, use the key name
      If Trim$(strDisplayName) = vbNullString Then
         strDisplayName = strKey
      End If
      
      vntTmp(1) = strDisplayName
      
      ' ---------------------------------------
      ' Get the Display version or alternate
      ' ---------------------------------------
      lngRtn = objRegistry.GetStringValue(HKLM, _
                                          BASE_KEY & strKey, _
                                          "DisplayVersion", _
                                          strDisplayVersion)

      ' Else, concatenate the version info
      If Trim$(strDisplayVersion) = vbNullString Then
         lngRtn = objRegistry.GetStringValue(HKLM, _
                                             BASE_KEY & strKey, _
                                             "VersionMajor", _
                                             strDisplayVersionMajor)
         lngRtn = objRegistry.GetStringValue(HKLM, _
                                             BASE_KEY & strKey, _
                                             "VersionMinor", _
                                             strDisplayVersionMinor)
         strDisplayVersion = strDisplayVersionMajor & "." & strDisplayVersionMinor
      End If
      
      ' If all else fails, try just the "Version" string
      If Trim$(strDisplayVersionMajor) = vbNullString Then
         lngRtn = objRegistry.GetStringValue(HKLM, _
                                             BASE_KEY & strKey, _
                                             "Version", _
                                             strDisplayVersion)
      End If
      
      vntTmp(2) = strDisplayVersion
      
      ' ---------------------------------------
      ' Get the installatin location
      ' ---------------------------------------
      lngRtn = objRegistry.GetStringValue(HKLM, _
                                          BASE_KEY & strKey, _
                                          "InstallLocation", _
                                          strInstallLocation)

      If Trim$(strInstallLocation) = vbNullString Then
         lngRtn = objRegistry.GetStringValue(HKLM, _
                                             BASE_KEY & strKey, _
                                             "UninstallString", _
                                             strInstallLocation)
      End If
      
      vntTmp(3) = strInstallLocation
   
      ' ---------------------------------------
      ' Get the installation Date
      ' ---------------------------------------
      lngRtn = objRegistry.GetStringValue(HKLM, _
                                          BASE_KEY & strKey, _
                                          "InstallDate", _
                                          strInstallDate)
      If Len(Trim$(strInstallDate)) > 0 Then
         vntTmp(4) = TransSoftwareDate(strInstallDate)
      End If
      
      ' ---------------------------------------
      ' Get the install-from location
      ' ---------------------------------------
      lngRtn = objRegistry.GetStringValue(HKLM, _
                                          BASE_KEY & strKey, _
                                          "InstallSource", _
                                          strInstallFrom)
      vntTmp(5) = strInstallFrom
      
      ' ---------------------------------------
      ' Set the array value
      ' ---------------------------------------
      If Trim$(vntTmp(1)) <> vbNullString Then
         lngIndex = lngIndex + 1
         vntRtnData(lngIndex) = vntTmp
      Else
         ' Don't add
         Debug.Print
      End If
      
   Next
   
   GetInstalledSoftwareData2 = vntRtnData
   
End Function

Public Function GetInstalledSoftwareData(ByVal xi_sWbemServices As SWbemServices, _
                                         ByRef xo_vntColHeadings As Variant) As Variant
On Error Resume Next
   Dim vntTmp                          As Variant
   Dim objInstalledSet                 As SWbemObjectSet
   Dim objInstalledSoftware            As SWbemObject
   Dim objProperty                     As SWbemProperty
   Dim lngIndex                        As Long
   Dim vntRtnData                      As Variant
   
   Set objInstalledSet = xi_sWbemServices.InstancesOf("Win32_Product")
   
   ReDim vntRtnData(1 To objInstalledSet.Count) As Variant
   
   ReDim xo_vntColHeadings(1 To 7) As String
   xo_vntColHeadings(1) = "Software"
   xo_vntColHeadings(2) = "Version"
   xo_vntColHeadings(3) = "Install Date"
   xo_vntColHeadings(4) = "Package Cache"
   xo_vntColHeadings(5) = "Install State"
   xo_vntColHeadings(6) = "GUID"
   xo_vntColHeadings(7) = "Vendor"

   For Each objInstalledSoftware In objInstalledSet
      ReDim vntTmp(1 To 7) As String
      
      For Each objProperty In objInstalledSoftware.Properties_
         With objProperty
            Select Case objProperty.Name
               Case "Description"
                  vntTmp(1) = .Value
               Case "Version"
                  vntTmp(2) = .Value
               Case "InstallDate"
                  vntTmp(3) = TransSoftwareDate(.Value)
               Case "PackageCache"
                  vntTmp(4) = .Value
               Case "InstallState"
                  Select Case .Value
                     Case -6
                        vntTmp(5) = "Bad Configuration"
                     Case -2
                        vntTmp(5) = "Invalid Argument"
                     Case -1
                        vntTmp(5) = "Unknown Package"
                     Case 1
                        vntTmp(5) = "Advertised"
                     Case 2
                        vntTmp(5) = "Absent"
                     Case 5
                        vntTmp(5) = "Installed"
                  End Select
               Case "IdentifyingNumber"
                  vntTmp(6) = .Value
               Case "Vendor"
                  vntTmp(7) = .Value
               Case Else
                  ' Ignore the rest
                  'Debug.Print .Name, .Value
            End Select
         End With
         
      Next
         
      If Len(Trim$(vntTmp(1, 0))) > 0 Then
         lngIndex = lngIndex + 1
         vntRtnData(lngIndex) = vntTmp
      End If
         
   Next

   GetInstalledSoftwareData = vntRtnData
   
End Function

Public Function GetServicesData(ByVal xi_sWbemServices As SWbemServices, _
                                ByRef xo_vntColHeadings As Variant) As Variant
On Error Resume Next
   Dim vntTmp                          As Variant
   Dim objServicesSet                  As SWbemObjectSet
   Dim objService                      As SWbemObject
   Dim objProperty                     As SWbemProperty
   Dim lngIndex                        As Long
   Dim vntRtnData                      As Variant
      
   Set objServicesSet = xi_sWbemServices.InstancesOf("Win32_Service")
   
   ReDim vntRtnData(1 To objServicesSet.Count) As Variant
   
   ReDim xo_vntColHeadings(1 To 13) As String
   xo_vntColHeadings(1) = "Display Name"
   xo_vntColHeadings(2) = "Description"
   xo_vntColHeadings(3) = "Started"
   xo_vntColHeadings(4) = "Start Mode"
   xo_vntColHeadings(5) = "State"
   xo_vntColHeadings(6) = "Started By"
   xo_vntColHeadings(7) = "Service Type"
   xo_vntColHeadings(8) = "Accept Pause"
   xo_vntColHeadings(9) = "Accept Stop"
   xo_vntColHeadings(10) = "Interact With Desktop"
   xo_vntColHeadings(11) = "Error Control"
   xo_vntColHeadings(12) = "Process ID"
   xo_vntColHeadings(13) = "Path Name"
   
   For Each objService In objServicesSet
      ReDim vntTmp(1 To 13) As String
      
      For Each objProperty In objService.Properties_
         With objProperty
            Select Case objProperty.Name
               Case "DisplayName"
                  vntTmp(1) = .Value
               Case "Description"
                  vntTmp(2) = .Value
               Case "Started"
                  vntTmp(3) = CStr(.Value)
               Case "StartMode"
                  vntTmp(4) = .Value
               Case "State"
                  vntTmp(5) = .Value
               Case "StartName"
                  vntTmp(6) = .Value
               Case "ServiceType"
                  vntTmp(7) = .Value
               Case "AcceptPause"
                  vntTmp(8) = CStr(.Value)
               Case "AcceptStop"
                  vntTmp(9) = CStr(.Value)
               Case "DesktopInteract"
                  vntTmp(10) = CStr(.Value)
               Case "ErrorControl"
                  vntTmp(11) = .Value
               Case "ProcessId"
                  vntTmp(12) = .Value
               Case "PathName"
                  vntTmp(13) = .Value
               Case Else
                  ' Ignore the rest
                  'Debug.Print .Name, .Value
            End Select
         End With
         
      Next
         
      If Len(Trim$(vntTmp(1, 0))) > 0 Then
         lngIndex = lngIndex + 1
         vntRtnData(lngIndex) = vntTmp
      End If
         
   Next

   GetServicesData = vntRtnData
   
End Function

Public Function GetPhysicalDiskData(ByVal xi_sWbemServices As SWbemServices, _
                                    ByRef xo_vntColHeadings As Variant) As Variant
On Error Resume Next
   Dim vntTmp                          As Variant
   Dim PhysicalDisks                   As SWbemObjectSet
   Dim PhysicalDisk                    As SWbemObject
   Dim objProperty                     As SWbemProperty
   Dim lngIndex                        As Long
   Dim vntRtnData                      As Variant
   
   Set PhysicalDisks = xi_sWbemServices.InstancesOf("Win32_DiskDrive")
   
   ReDim vntRtnData(1 To PhysicalDisks.Count) As Variant
   
   ReDim xo_vntColHeadings(1 To 16) As String
   xo_vntColHeadings(1) = "Name"
   xo_vntColHeadings(2) = "Caption"
   xo_vntColHeadings(3) = "Interface"
   xo_vntColHeadings(4) = "Media Type"
   xo_vntColHeadings(5) = "Model"
   xo_vntColHeadings(6) = "Partitions"
   xo_vntColHeadings(7) = "Size (Megs)"
   xo_vntColHeadings(8) = "Tracks/Cylinder"
   xo_vntColHeadings(9) = "Sectors/Track"
   xo_vntColHeadings(10) = "Bytes/Sector"
   xo_vntColHeadings(11) = "Total Cylinders"
   xo_vntColHeadings(12) = "Total Heads"
   xo_vntColHeadings(13) = "Total Sectors"
   xo_vntColHeadings(14) = "Total Tracks"
   xo_vntColHeadings(15) = "Device ID"
   xo_vntColHeadings(16) = "Manufacturer"
   
   For Each PhysicalDisk In PhysicalDisks
      ReDim vntTmp(1 To 16) As String
      
      For Each objProperty In PhysicalDisk.Properties_
         With objProperty
            Select Case objProperty.Name
               Case "Name"
                  vntTmp(1) = .Value
               Case "Caption"
                  vntTmp(2) = .Value
               Case "InterfaceType"
                  vntTmp(3) = .Value
               Case "MediaType"
                  vntTmp(4) = .Value
               Case "Model"
                  vntTmp(5) = .Value
               Case "Partitions"
                  vntTmp(6) = .Value
               Case "Size"
                  vntTmp(7) = TransMeg(.Value) & " Megs"
               Case "TracksPerCylinder"
                  vntTmp(8) = .Value
               Case "SectorsPerTrack"
                  vntTmp(9) = .Value
               Case "BytesPerSector"
                  vntTmp(10) = .Value
               Case "TotalCylinders"
                  vntTmp(11) = .Value
               Case "TotalHeads"
                  vntTmp(12) = .Value
               Case "TotalSectors"
                  vntTmp(13) = .Value
               Case "TotalTracks"
                  vntTmp(14) = .Value
               Case "DeviceID"
                  vntTmp(15) = .Value
               Case "Manufacturer"
                  vntTmp(16) = .Value
               Case Else
                  ' Ignore the rest
                  Debug.Print .Name, .Value
            End Select
         End With
         
      Next
         
      If Len(Trim$(vntTmp(1, 0))) > 0 Then
         lngIndex = lngIndex + 1
         vntRtnData(lngIndex) = vntTmp
      End If
         
   Next

   GetPhysicalDiskData = vntRtnData
   
End Function

Public Function GetNetAdapterData(ByVal xi_sWbemServices As SWbemServices, _
                                  ByRef xo_vntColHeadings As Variant) As Variant
On Error Resume Next
   Dim vntTmp                          As Variant
   Dim objNetAdapterSet                As SWbemObjectSet
   Dim objNetAdapter                   As SWbemObject
   Dim objNetAdapterSet2               As SWbemObjectSet
   Dim objNetAdapter2                  As SWbemObject
   Dim objProperty                     As SWbemProperty
   Dim lngIndex                        As Long
   Dim vntRtnData                      As Variant
   
   Set objNetAdapterSet = xi_sWbemServices.InstancesOf("Win32_NetworkAdapter")
   
   ReDim vntRtnData(1 To objNetAdapterSet.Count) As Variant
   
   ReDim xo_vntColHeadings(1 To 11) As String
   xo_vntColHeadings(1) = "Description"
   xo_vntColHeadings(2) = "IP Address"
   xo_vntColHeadings(3) = "MAC Address"
   xo_vntColHeadings(4) = "Net Connection ID"
   xo_vntColHeadings(5) = "Net Connection Status"
   xo_vntColHeadings(6) = "Manufacturer"
   xo_vntColHeadings(7) = "Service Name"
   xo_vntColHeadings(8) = "Availability"
   xo_vntColHeadings(9) = "Adapter Type"
   xo_vntColHeadings(10) = "Power Management Suppported"
   xo_vntColHeadings(11) = "PNP Device ID"
   
   For Each objNetAdapter In objNetAdapterSet
      ReDim vntTmp(1 To 11) As String
      
      For Each objProperty In objNetAdapter.Properties_
         With objProperty
            Select Case objProperty.Name
               Case "Description"
                  vntTmp(1) = .Value
               Case "MACAddress"
                  vntTmp(3) = .Value
               Case "NetConnectionID"
                  vntTmp(4) = .Value
               Case "NetConnectionStatus"
                  Select Case .Value
                     Case 0
                        vntTmp(5) = "Disconnected"
                     Case 1
                        vntTmp(5) = "Connecting"
                     Case 2
                        vntTmp(5) = "Connected"
                     Case 3
                        vntTmp(5) = "Disconnecting"
                     Case 4
                        vntTmp(5) = "Hardware not present"
                     Case 5
                        vntTmp(5) = "Hardware disabled"
                     Case 6
                        vntTmp(5) = "Hardware malfunction"
                     Case 7
                        vntTmp(5) = "Media disconnected"
                     Case 8
                        vntTmp(5) = "Authenticating"
                     Case 9
                        vntTmp(5) = "Authentication succeeded"
                     Case 10
                        vntTmp(5) = "Authentication failed"
                  End Select
               Case "Manufacturer"
                  vntTmp(6) = .Value
               Case "ServiceName"
                  vntTmp(7) = .Value
               Case "Availability"
                  Select Case .Value
                     Case 1
                        vntTmp(8) = "Other"
                     Case 2
                        vntTmp(8) = "Unknown"
                     Case 3
                        vntTmp(8) = "Running/Full Power"
                     Case 4
                        vntTmp(8) = "Warning"
                     Case 5
                        vntTmp(8) = "In Test"
                     Case 6
                        vntTmp(8) = "Not Applicable"
                     Case 7
                        vntTmp(8) = "Power Off"
                     Case 8
                        vntTmp(8) = "Off Line"
                     Case 9
                        vntTmp(8) = "Off Duty"
                     Case 10
                        vntTmp(8) = "Degraded"
                     Case 11
                        vntTmp(8) = "Not Installed"
                     Case 12
                        vntTmp(8) = "Install Error"
                     Case 13
                        vntTmp(8) = "Power Save - Unknown"
                     Case 14
                        vntTmp(8) = "Power Save - Low Power Mode"
                     Case 15
                        vntTmp(8) = "Power Save - Standby"
                     Case 16
                        vntTmp(8) = "Power Cycle"
                     Case 17
                        vntTmp(8) = "Power Save - Warning"
                  End Select
               Case "AdapterType"
                  vntTmp(9) = .Value
               Case "PowerManagementSupported"
                  vntTmp(10) = CStr(.Value)
               Case "PNPDeviceID"
                  vntTmp(11) = .Value
               Case Else
                  ' Ignore the rest
                  'Debug.Print .Name, .Value
            End Select

         End With
         
      Next

      If Len(Trim$(vntTmp(3))) > 0 Then
         Set objNetAdapterSet2 = xi_sWbemServices.ExecQuery("Select IPAddress From Win32_NetworkAdapterConfiguration WHERE MACAddress = '" & vntTmp(3) & "'")
         For Each objNetAdapter2 In objNetAdapterSet2
            For Each objProperty In objNetAdapter2.Properties_
               With objProperty
                  'If Not (objProperty Is Nothing) Then
                     If .Name = "IPAddress" Then
                        If VarType(.Value) = (vbArray + vbVariant) Then
                           vntTmp(2) = .Value(0)
                        End If
                     End If
                  'End If
               End With
            Next
         Next
      End If
      
      If Len(Trim$(vntTmp(1, 0))) > 0 Then
         lngIndex = lngIndex + 1
         vntRtnData(lngIndex) = vntTmp
      End If
         
   Next

   GetNetAdapterData = vntRtnData

End Function

Public Function GetLogicalDiskData(ByVal xi_sWbemServices As SWbemServices, _
                                   ByRef xo_vntColHeadings As Variant) As Variant
On Error Resume Next
   Dim vntTmp                          As Variant
   Dim LogicalDisks                    As SWbemObjectSet
   Dim LogicalDisk                     As SWbemObject
   Dim objProperty                     As SWbemProperty
   Dim lngIndex                        As Long
   Dim curTotalSize                    As Currency
   Dim curTotalFree                    As Currency
   Dim curTotalUsed                    As Currency
   Dim dblPercentFree                  As Double
   Dim vntRtnData                      As Variant
   
   Set LogicalDisks = xi_sWbemServices.InstancesOf("Win32_LogicalDisk " & _
                                                   "WHERE (DriveType <> 2 OR " & _
                                                   "(DriveType = 2 and MediaType = 11))")
   
   ReDim vntRtnData(1 To LogicalDisks.Count) As Variant
   
   ReDim xo_vntColHeadings(1 To 15) As String
   xo_vntColHeadings(1) = "Drive Letter"
   xo_vntColHeadings(2) = "File System"
   xo_vntColHeadings(3) = "Description"
   xo_vntColHeadings(4) = "Disk Size"
   xo_vntColHeadings(5) = "Free Space"
   xo_vntColHeadings(6) = "% Free Space"
   xo_vntColHeadings(7) = "Used Space"
   xo_vntColHeadings(8) = "Volume Name"
   xo_vntColHeadings(9) = "Remote Name"
   xo_vntColHeadings(10) = "Supports File Compression"
   xo_vntColHeadings(11) = "Supports Disk Quotas"
   xo_vntColHeadings(12) = "Disk Quota Disabled"
   xo_vntColHeadings(13) = "Serial Number"
   xo_vntColHeadings(14) = "Drive Type"
   xo_vntColHeadings(15) = "Media Type"
   
   For Each LogicalDisk In LogicalDisks
      ReDim vntTmp(1 To 15) As String
      
      curTotalSize = 0
      curTotalFree = 0
      curTotalUsed = 0
      dblPercentFree = 0
      
      For Each objProperty In LogicalDisk.Properties_
         With objProperty
            Select Case objProperty.Name
               Case "Name"
                  vntTmp(1) = .Value
               Case "FileSystem"
                  vntTmp(2) = .Value
               Case "Description"
                  vntTmp(3) = .Value
               Case "Size"
                  vntTmp(4) = TransMeg(.Value) & " Megs"
                  curTotalSize = .Value
               Case "FreeSpace"
                  vntTmp(5) = TransMeg(.Value) & " Megs"
                  curTotalFree = .Value
               Case "VolumeName"
                  vntTmp(8) = .Value
               Case "ProviderName"
                  vntTmp(9) = .Value
               Case "SupportsFileBasedCompression"
                  vntTmp(10) = CStr(.Value)
               Case "SupportsDiskQuotas"
                  vntTmp(11) = CStr(.Value)
               Case "QuotasDisabled"
                  vntTmp(12) = CStr(.Value)
               Case "VolumeSerialNumber"
                  vntTmp(13) = .Value
               Case "DriveType"
                  Select Case .Value
                     Case 0
                        vntTmp(14) = "Unknown"
                     Case 1
                        vntTmp(14) = "No Root Directory"
                     Case 2
                        vntTmp(14) = "Removable Disk"
                     Case 3
                        vntTmp(14) = "Local Disk"
                     Case 4
                        vntTmp(14) = "Network Drive"
                     Case 5
                        vntTmp(14) = "CD"
                     Case 6
                        vntTmp(14) = "RAM Disk"
                  End Select
               Case "MediaType"
                  vntTmp(15) = GetMediaType(.Value)
               Case Else
                  ' Ignore the rest
                  'Debug.Print .Name, .Value
            End Select
         

         End With
         
      Next
         
      curTotalUsed = curTotalSize - curTotalFree
      dblPercentFree = curTotalFree / curTotalSize
      If curTotalSize > 0 Then
         vntTmp(6) = TransPercent(dblPercentFree)
         vntTmp(7) = TransMeg(curTotalUsed) & " Megs"
      Else
         vntTmp(6) = "N/A"
         vntTmp(7) = "0 Megs"
      End If
      
      If Len(Trim$(vntTmp(1, 0))) > 0 Then
         lngIndex = lngIndex + 1
         vntRtnData(lngIndex) = vntTmp
      End If
         
   Next

   GetLogicalDiskData = vntRtnData
   
End Function

Private Function GetMediaType(ByVal xi_lngPassed As Long) As String

   Select Case xi_lngPassed
      Case 0
         GetMediaType = "Unknown Format"
      Case 1
         GetMediaType = "5 1/4-Inch Floppy Disk - 1.2Mb"
      Case 2
         GetMediaType = "3 1/2-Inch Floppy Disk - 1.44Mb"
      Case 3
         GetMediaType = "3 1/2-Inch Floppy Disk - 2.88Mb"
      Case 4
         GetMediaType = "3 1/2-Inch Floppy Disk - 20.8Mb"
      Case 5
         GetMediaType = "3 1/2-Inch Floppy Disk - 720Kb"
      Case 6
         GetMediaType = "5 1/4-Inch Floppy Disk - 360Kb"
      Case 7
         GetMediaType = "5 1/4-Inch Floppy Disk - 320Kb"
      Case 8
         GetMediaType = "5 1/4-Inch Floppy Disk - 320Kb"
      Case 9
         GetMediaType = "5 1/4-Inch Floppy Disk - 180Kb"
      Case 10
         GetMediaType = "5 1/4-Inch Floppy Disk - 160Kb"
      Case 11
         GetMediaType = "Removable media other than floppy"
      Case 12
         GetMediaType = "Fixed hard disk media"
      Case 13
         GetMediaType = "3 1/2-Inch Floppy Disk - 120Mb"
      Case 14
         GetMediaType = "3 1/2-Inch Floppy Disk - 640Kb"
      Case 15
         GetMediaType = "5 1/4-Inch Floppy Disk - 640Kb"
      Case 16
         GetMediaType = "5 1/4-Inch Floppy Disk - 720Kb"
      Case 17
         GetMediaType = "3 1/2-Inch Floppy Disk - 1.2Mb"
      Case 18
         GetMediaType = "3 1/2-Inch Floppy Disk - 1.23Mb"
      Case 19
         GetMediaType = "5 1/4-Inch Floppy Disk - 1.23Mb"
      Case 20
         GetMediaType = "3 1/2-Inch Floppy Disk - 128Mb"
      Case 21
         GetMediaType = "3 1/2-Inch Floppy Disk - 230Mb"
      Case 22
         GetMediaType = "8-Inch Floppy Disk - 256Kb"
   End Select
               

End Function

Public Function GetVideoData(ByVal xi_sWbemServices As SWbemServices) As Variant
On Error Resume Next
   Dim objVideoSet                     As SWbemObjectSet
   Dim objVideo                        As SWbemObject
   Dim objProperty                     As SWbemProperty
   Dim vntRtnData                      As Variant

   Set objVideoSet = xi_sWbemServices.InstancesOf("Win32_VideoController")
   
   ReDim vntRtnData(0 To 1, 1 To 23) As Variant
   
   For Each objVideo In objVideoSet
      For Each objProperty In objVideo.Properties_
         With objProperty
            Select Case .Name

               Case "Name"
                  vntRtnData(0, 1) = "Video Card"
                  vntRtnData(1, 1) = .Value
               Case "AdapterRAM"
                  vntRtnData(0, 2) = "Adapter RAM"
                  vntRtnData(1, 2) = TransMeg(.Value) & " Meg"
               Case "VideoModeDescription"
                  vntRtnData(0, 3) = "Video Mode"
                  vntRtnData(1, 3) = .Value
               Case "VideoProcessor"
                  vntRtnData(0, 4) = "Video Processor"
                  vntRtnData(1, 4) = .Value
               Case "VideoArchitecture"
                  vntRtnData(0, 5) = "Video Architecture"
                  Select Case .Value
                     Case 1
                        vntRtnData(1, 5) = "Other"
                     Case 2
                        vntRtnData(2, 5) = "Unknown"
                     Case 3
                        vntRtnData(3, 5) = "CGA"
                     Case 4
                        vntRtnData(4, 5) = "EGA"
                     Case 5
                        vntRtnData(5, 5) = "VGA"
                     Case 6
                        vntRtnData(6, 5) = "SVGA"
                     Case 7
                        vntRtnData(7, 5) = "MDA"
                     Case 8
                        vntRtnData(8, 5) = "HGC"
                     Case 9
                        vntRtnData(9, 5) = "MCGA"
                     Case 10
                        vntRtnData(19, 5) = "8514A"
                     Case 11
                        vntRtnData(11, 5) = "XGA"
                     Case 12
                        vntRtnData(12, 5) = "Linear Frame Buffer"
                     Case 160
                        vntRtnData(1, 5) = "PC-98"
                  End Select
               Case "VideoMemoryType"
                  vntRtnData(0, 6) = "Video Memory Type"
                  Select Case .Value
                     Case 1
                        vntRtnData(1, 6) = "Other"
                     Case 2
                        vntRtnData(1, 6) = "Unknown"
                     Case 3
                        vntRtnData(1, 6) = "VRAM"
                     Case 4
                        vntRtnData(1, 6) = "DRAM"
                     Case 5
                        vntRtnData(1, 6) = "SRAM"
                     Case 6
                        vntRtnData(1, 6) = "WRAM"
                     Case 7
                        vntRtnData(1, 6) = "EDO RAM"
                     Case 8
                        vntRtnData(1, 6) = "Burst Synchronous DRAM"
                     Case 9
                        vntRtnData(1, 6) = "Pipelined Burst SRAM"
                     Case 10
                        vntRtnData(1, 6) = "CDRAM"
                     Case 11
                        vntRtnData(1, 6) = "3DRAM"
                     Case 12
                        vntRtnData(1, 6) = "SDRAM"
                     Case 13
                        vntRtnData(1, 6) = "SGRAM"
                  End Select
               Case "AdapterCompatibility"
                  vntRtnData(0, 7) = "Adapter Compatibility"
                  vntRtnData(1, 7) = .Value
               Case "AdapterDACType"
                  vntRtnData(0, 8) = "Adapter DAC Type"
                  vntRtnData(1, 8) = .Value
               Case "CurrentBitsPerPixel"
                  vntRtnData(0, 9) = "Current Bits/Pixel"
                  vntRtnData(1, 9) = .Value
               Case "CurrentHorizontalResolution"
                  vntRtnData(0, 10) = "Current Horizontal Resolution"
                  vntRtnData(1, 10) = .Value
               Case "CurrentVerticalResolution"
                  vntRtnData(0, 11) = "Current Vertical Resolution"
                  vntRtnData(1, 11) = .Value
               Case "CurrentNumberOfColors"
                  vntRtnData(0, 12) = "Current # of Colors"
                  vntRtnData(1, 12) = .Value
               Case "CurrentRefreshRate"
                  vntRtnData(0, 13) = "Current Refresh Rate"
                  vntRtnData(1, 13) = .Value
               Case "CurrentScanMode"
                  vntRtnData(0, 14) = "Current Scan Mode"
                  Select Case .Value
                     Case 1
                        vntRtnData(1, 14) = "Other"
                     Case 2
                        vntRtnData(1, 14) = "Unknown"
                     Case 3
                        vntRtnData(1, 14) = "Interlaced"
                     Case 4
                        vntRtnData(1, 14) = "Non Interlaced"
                  End Select
               Case "NumberOfColorPlanes"
                  vntRtnData(0, 15) = "Number of Color Planes"
                  vntRtnData(1, 15) = .Value
               Case "MaxRefreshRate"
                  vntRtnData(0, 16) = "Max Refresh Rate"
                  vntRtnData(1, 16) = .Value
               Case "MinRefreshRate"
                  vntRtnData(0, 17) = "Min Refresh Rate"
                  vntRtnData(1, 17) = .Value
               Case "InstalledDisplayDrivers"
                  vntRtnData(0, 18) = "Installed Display Drivers"
                  vntRtnData(1, 18) = .Value
               Case "DriverDate"
                  vntRtnData(0, 19) = "Driver Date"
                  vntRtnData(1, 19) = TransDate(.Value)
               Case "DriverVersion"
                  vntRtnData(0, 20) = "Driver Version"
                  vntRtnData(1, 20) = .Value
               Case "InfFilename"
                  vntRtnData(0, 21) = "Driver INF Name"
                  vntRtnData(1, 21) = .Value
               Case "InfSection"
                  vntRtnData(0, 22) = "Driver INF Section"
                  vntRtnData(1, 22) = .Value
               Case "DeviceID"
                  vntRtnData(0, 23) = "Device ID"
                  vntRtnData(1, 23) = .Value
               Case Else
                  ' Ignore the rest
                  'Debug.Print .Name, .Value
            End Select
         End With
      Next
   Next
   
   GetVideoData = vntRtnData
   
End Function

Public Function GetComputerSystemData(ByVal xi_sWbemServices As SWbemServices) As Variant
On Error Resume Next
   Dim ComputerSysSet                  As SWbemObjectSet
   Dim ComputerSystem                  As SWbemObject
   Dim objProperty                     As SWbemProperty
   Dim vntRtnData                      As Variant

   Set ComputerSysSet = xi_sWbemServices.InstancesOf("Win32_ComputerSystem")
   
   ReDim vntRtnData(0 To 1, 1 To 24) As Variant
   
   For Each ComputerSystem In ComputerSysSet
      For Each objProperty In ComputerSystem.Properties_
         With objProperty
            Select Case objProperty.Name
               Case "TotalPhysicalMemory"
                  vntRtnData(0, 1) = "Total Physical Memory"
                  vntRtnData(1, 1) = TransK(.Value) & " K"
               Case "SystemType"
                  vntRtnData(0, 2) = "System Type"
                  vntRtnData(1, 2) = .Value
               Case "Domain"
                  vntRtnData(0, 3) = "Domain"
                  vntRtnData(1, 3) = .Value
               Case "NumberOfProcessors"
                  vntRtnData(0, 4) = "Number of Processors"
                  vntRtnData(1, 4) = .Value
               Case "PrimaryOwnerName"
                  vntRtnData(0, 5) = "Primary Owner Name"
                  vntRtnData(1, 5) = .Value
               Case "Description"
                  vntRtnData(0, 6) = "Description"
                  vntRtnData(1, 6) = .Value
               Case "EnableDaylightSavingsTime"
                  vntRtnData(0, 7) = "Daylight Savings Enabled"
                  vntRtnData(1, 7) = CStr(.Value)
               Case "UserName"
                  vntRtnData(0, 8) = "Current User Name"
                  vntRtnData(1, 8) = .Value
               Case "AdminPasswordStatus"
                  vntRtnData(0, 9) = "Admin Password Status"
                  Select Case .Value
                     Case 1
                        vntRtnData(1, 9) = "Disabled"
                     Case 2
                        vntRtnData(1, 9) = "Enabled"
                     Case 3
                        vntRtnData(1, 9) = "Not Implemented"
                     Case 4
                        vntRtnData(1, 9) = "Unknown"
                  End Select
               Case "AutomaticResetBootOption"
                  vntRtnData(0, 10) = "Auto Reset Boot Option"
                  vntRtnData(1, 10) = CStr(.Value)
               Case "AutomaticResetCapability"
                  vntRtnData(0, 11) = "Auto Reset Capability"
                  vntRtnData(1, 11) = CStr(.Value)
               Case "BootROMSupported"
                  vntRtnData(0, 12) = "Boot ROM Supported"
                  vntRtnData(1, 12) = CStr(.Value)
               Case "InfraredSupported"
                  vntRtnData(0, 13) = "Infrared Supported"
                  vntRtnData(1, 13) = CStr(.Value)
               Case "NetworkServerModeEnabled"
                  vntRtnData(0, 14) = "Network Server Mode"
                  vntRtnData(1, 14) = CStr(.Value)
               Case "DomainRole"
                  vntRtnData(0, 15) = "Domain Role"
                  Select Case .Value
                     Case 0
                        vntRtnData(1, 15) = "Standalone Workstation"
                     Case 1
                        vntRtnData(1, 15) = "Member Workstation"
                     Case 2
                        vntRtnData(1, 15) = "Standalone Server"
                     Case 3
                        vntRtnData(1, 15) = "Member Server"
                     Case 4
                        vntRtnData(1, 15) = "Backup DC"
                     Case 5
                        vntRtnData(1, 15) = "Primary DC"
                     Case Else
                        vntRtnData(1, 15) = "Unknown"
                  End Select
               Case "PartOfDomain"
                  vntRtnData(0, 16) = "Part of Domain"
                  vntRtnData(1, 16) = CStr(.Value)
               Case "BootupState"
                  vntRtnData(0, 17) = "Bootup State"
                  vntRtnData(1, 17) = .Value
               Case "FrontPanelResetStatus"
                  vntRtnData(0, 18) = "Front Panel Reset Status"
                  Select Case .Value
                     Case 0
                        vntRtnData(1, 18) = "Disabled"
                     Case 1
                        vntRtnData(1, 18) = "Enabled"
                     Case 2
                        vntRtnData(1, 18) = "Not Implemented"
                     Case 3
                        vntRtnData(1, 18) = "Unknown"
                  End Select
               Case "KeyboardPasswordStatus"
                  vntRtnData(0, 19) = "Keyboard Password Status"
                  Select Case .Value
                     Case 0
                        vntRtnData(1, 19) = "Disabled"
                     Case 1
                        vntRtnData(1, 19) = "Enabled"
                     Case 2
                        vntRtnData(1, 19) = "Not Implemented"
                     Case 3
                        vntRtnData(1, 19) = "Unknown"
                  End Select
               Case "PowerOnPasswordStatus"
                  vntRtnData(0, 20) = "Power-on Password Status"
                  Select Case .Value
                     Case 0
                        vntRtnData(1, 20) = "Disabled"
                     Case 1
                        vntRtnData(1, 20) = "Enabled"
                     Case 2
                        vntRtnData(1, 20) = "Not Implemented"
                     Case 3
                        vntRtnData(1, 20) = "Unknown"
                  End Select
               Case "PowerSupplyState"
                  vntRtnData(0, 21) = "Power Supply State"
                  Select Case .Value
                     Case 1
                        vntRtnData(1, 21) = "Other"
                     Case 2
                        vntRtnData(1, 21) = "Unknown"
                     Case 3
                        vntRtnData(1, 21) = "Save"
                     Case 4
                        vntRtnData(1, 21) = "Warning"
                     Case 5
                        vntRtnData(1, 21) = "Critical"
                     Case 6
                        vntRtnData(1, 21) = "Non-recoverable"
                  End Select
               Case "ThermalState"
                  vntRtnData(0, 22) = "Thermal State"
                  Select Case .Value
                     Case 1
                        vntRtnData(1, 22) = "Other"
                     Case 2
                        vntRtnData(1, 22) = "Unknown"
                     Case 3
                        vntRtnData(1, 22) = "Safe"
                     Case 4
                        vntRtnData(1, 22) = "Warning"
                     Case 5
                        vntRtnData(1, 22) = "Critical"
                     Case 6
                        vntRtnData(1, 22) = "Non-recoverable"
                  End Select
               Case "ResetCapability"
                  vntRtnData(0, 23) = "Reset Capability"
                  Select Case .Value
                     Case 1
                        vntRtnData(1, 23) = "Other"
                     Case 2
                        vntRtnData(1, 23) = "Unknown"
                     Case 3
                        vntRtnData(1, 23) = "Disabled"
                     Case 4
                        vntRtnData(1, 23) = "Enabled"
                     Case 5
                        vntRtnData(1, 23) = "Non-recoverable"
                  End Select
               Case "SystemStartupDelay"
                  vntRtnData(0, 24) = "System Startup Delay (secs)"
                  vntRtnData(1, 24) = .Value
               Case Else
                  ' Ignore the rest
                  'Debug.Print .Name, .Value
            End Select
         End With
      Next
   Next
   
   GetComputerSystemData = vntRtnData
   
End Function

Public Function GetProcessData(ByVal xi_sWbemServices As SWbemServices, _
                               ByRef xo_vntColHeadings As Variant) As Variant
On Error Resume Next
   Dim ProcessSet                      As SWbemObjectSet
   Dim Process                         As SWbemObject
   Dim objProperty                     As SWbemProperty
   Dim vntRtnData                      As Variant
   Dim vntTmp                          As Variant
   Dim lngIndex                        As Long
   Dim strQuery                        As String
   Dim colEnum                         As SWbemObjectSet
   Dim objInstance                     As SWbemObject
   Dim curTotalTime                    As Currency
   Dim curProcTime                     As Currency
   
   Set ProcessSet = xi_sWbemServices.InstancesOf("Win32_Process")
   
   ReDim vntTmp(1 To 8) As Variant
   
   ReDim xo_vntColHeadings(1 To 8) As String
   xo_vntColHeadings(1) = "Image Name"
   xo_vntColHeadings(2) = "PID"
   xo_vntColHeadings(3) = "CPU %"
   xo_vntColHeadings(4) = "Mem Usage"
   xo_vntColHeadings(5) = "Peak Mem"
   xo_vntColHeadings(6) = "Handle Count"
   xo_vntColHeadings(7) = "Thread Count"
   xo_vntColHeadings(8) = "Priority"
   
   ReDim vntRtnData(1 To ProcessSet.Count) As Variant
   
   ' Get the total time
   strQuery = "Select * From " & "Win32_PerfRawData_PerfProc_Process " & _
              "Where Name = '_Total'"
   Set colEnum = xi_sWbemServices.ExecQuery(strQuery, "WQL")
   
   On Error Resume Next
   For Each objInstance In colEnum
      If objInstance.Name = "_Total" Then
         curTotalTime = CCur(objInstance.PercentProcessorTime)
         Exit For
      End If
   Next
   On Error GoTo 0
   
   ' Get the processes
   For Each Process In ProcessSet
      For Each objProperty In Process.Properties_
         With objProperty
            Select Case .Name
               Case "Name"
                  vntTmp(1) = .Value
               Case "ProcessId"
                  vntTmp(2) = .Value
               'Case "CPU"
               '   vntTmp(3) = .Value
               Case "WorkingSetSize"
                  vntTmp(4) = TransK(.Value) & " K"
               Case "PeakWorkingSetSize"
                  vntTmp(5) = TransK(.Value) & " K"
               Case "HandleCount"
                  vntTmp(6) = .Value
               Case "ThreadCount"
                  vntTmp(7) = .Value
               Case "Priority"
                  vntTmp(8) = .Value
               Case Else
                  On Error Resume Next
                  ' Ignore the rest
                  'Debug.Print .Name, .Value
            End Select
         End With
      Next
      
      strQuery = "Select * From " & "Win32_PerfRawData_PerfProc_Process " & _
                 "Where IDProcess = " & Trim$(vntTmp(2))
      Set colEnum = xi_sWbemServices.ExecQuery(strQuery, "WQL")
   
      On Error Resume Next
      vntTmp(3) = vbNullString
      For Each objInstance In colEnum
         curProcTime = (objInstance.PercentProcessorTime)
         vntTmp(3) = TransPercent(curProcTime / curTotalTime)
         Exit For
      Next
      On Error GoTo 0
      
      If Len(Trim$(vntTmp(1))) > 0 Then
         lngIndex = lngIndex + 1
         vntRtnData(lngIndex) = vntTmp
      End If
         
      'Debug.Print vntTmp(1)
   Next

   GetProcessData = vntRtnData
   
End Function

Public Function GetPageFileData(ByVal xi_sWbemServices As SWbemServices, _
                                ByRef xo_vntColHeadings As Variant) As Variant
On Error Resume Next
   Dim PageFileSet                     As SWbemObjectSet
   Dim PageFile                        As SWbemObject
   Dim objProperty                     As SWbemProperty
   Dim vntRtnData                      As Variant
   Dim vntTmp                          As Variant
   Dim lngIndex                        As Long
   
   Set PageFileSet = xi_sWbemServices.InstancesOf("Win32_PageFile")
   
   ReDim vntTmp(1 To 6) As Variant
   
   ReDim xo_vntColHeadings(1 To 6) As String
   xo_vntColHeadings(1) = "Name"
   xo_vntColHeadings(2) = "Current File Size"
   xo_vntColHeadings(3) = "Maximum File Size"
   xo_vntColHeadings(4) = "File System"
   xo_vntColHeadings(5) = "Compressed"
   xo_vntColHeadings(6) = "Encrypted"
   
   ReDim vntRtnData(1 To PageFileSet.Count) As Variant
   
   For Each PageFile In PageFileSet
      For Each objProperty In PageFile.Properties_
         With objProperty
            Select Case .Name
               Case "Caption"
                  vntTmp(1) = .Value
               Case "FileSize"
                  vntTmp(2) = TransMeg(.Value) & " Meg"
               Case "MaximumSize"
                  vntTmp(3) = .Value & " Meg"
               Case "FSName"
                  vntTmp(4) = .Value
               Case "Compressed"
                  vntTmp(5) = CStr(.Value)
               Case "Encrypted"
                  vntTmp(6) = CStr(.Value)
               Case Else
                  On Error Resume Next
                  ' Ignore the rest
                  'Debug.Print .Name, .Value
            End Select
         End With
      Next
   
      If Len(Trim$(vntTmp(1, 0))) > 0 Then
         lngIndex = lngIndex + 1
         vntRtnData(lngIndex) = vntTmp
      End If
         
   Next

   GetPageFileData = vntRtnData
   
End Function

Public Function GetOsData(ByVal xi_sWbemServices As SWbemServices) As Variant
On Error Resume Next
   Dim OSSet                           As SWbemObjectSet
   Dim OS                              As SWbemObject
   Dim objProperty                     As SWbemProperty
   Dim vntRtnData                      As Variant

   Set OSSet = xi_sWbemServices.InstancesOf("Win32_OperatingSystem")
   
   ReDim vntRtnData(0 To 1, 1 To 32) As Variant
   
   For Each OS In OSSet
      For Each objProperty In OS.Properties_
         With objProperty
            Select Case .Name
               Case "FreePhysicalMemory"
                  vntRtnData(0, 1) = "Free Physical Memory"
                  vntRtnData(1, 1) = TransK(.Value) & " K"
               Case "FreeVirtualMemory"
                  vntRtnData(0, 2) = "Free Virtual Memory"
                  vntRtnData(1, 2) = TransK(.Value) & " K"
               Case "TotalVirtualMemorySize"
                  vntRtnData(0, 3) = "Total Virtual Memmory Size"
                  vntRtnData(1, 3) = TransK(.Value) & " K"
               Case "TotalVisibleMemorySize"
                  vntRtnData(0, 4) = "Total Visible Memory Size"
                  vntRtnData(1, 4) = TransK(.Value) & " K"
               Case "SizeStoredInPagingFiles"
                  vntRtnData(0, 5) = "Size Stored in Paging File(s)"
                  vntRtnData(1, 5) = TransK(.Value) & " K"
               Case "FreeSpaceInPagingFiles"
                  vntRtnData(0, 6) = "Free Space in Paging File(s)"
                  vntRtnData(1, 6) = TransK(.Value) & " K"
               Case "CodeSet"
                  vntRtnData(0, 7) = "Code Set"
                  vntRtnData(1, 7) = .Value
               Case "CountryCode"
                  vntRtnData(0, 8) = "Country Code"
                  vntRtnData(1, 8) = .Value
               Case "Locale"
                  vntRtnData(0, 9) = "Locale"
                  vntRtnData(1, 9) = .Value
               Case "InstallDate"
                  vntRtnData(0, 10) = "OS Installation Date"
                  vntRtnData(1, 10) = TransDate(.Value)
               Case "LastBootUpTime"
                  vntRtnData(0, 11) = "Last Boot-up Time"
                  vntRtnData(1, 11) = TransDate(.Value)
               Case "Organization"
                  vntRtnData(0, 12) = "Organization"
                  vntRtnData(1, 12) = .Value
               Case "Version"
                  vntRtnData(0, 13) = "Version"
                  vntRtnData(1, 13) = .Value
               Case "WindowsDirectory"
                  vntRtnData(0, 14) = "Windows Directory"
                  vntRtnData(1, 14) = .Value
               Case "SystemDirectory"
                  vntRtnData(0, 15) = "System Directory"
                  vntRtnData(1, 15) = .Value
               Case "RegisteredUser"
                  vntRtnData(0, 16) = "Registered User"
                  vntRtnData(1, 16) = .Value
               Case "NumberOfUsers"
                  vntRtnData(0, 17) = "Number of Users"
                  vntRtnData(1, 17) = .Value
               Case "NumberOfProcesses"
                  vntRtnData(0, 18) = "Number of Processes"
                  vntRtnData(1, 18) = .Value
               Case "BuildType"
                  vntRtnData(0, 19) = "Build Type"
                  vntRtnData(1, 19) = .Value
               Case "BuildNumber"
                  vntRtnData(0, 20) = "Build Number"
                  vntRtnData(1, 20) = .Value
               Case "Caption"
                  vntRtnData(0, 21) = "Caption"
                  vntRtnData(1, 21) = .Value
               Case "Primary"
                  vntRtnData(0, 22) = "Primary OS?"
                  vntRtnData(1, 22) = CStr(.Value)
               Case "OSType"
                  vntRtnData(0, 23) = "OS Type"
                  Select Case .Value
                     Case 15
                        vntRtnData(1, 23) = "Win 3x"
                     Case 16
                        vntRtnData(1, 23) = "Windows 95"
                     Case 17
                        vntRtnData(1, 23) = "Windows 98"
                     Case 18
                        vntRtnData(1, 23) = "NT Family"
                     Case 19
                        vntRtnData(1, 23) = "Win CE"
                     Case Else
                        vntRtnData(1, 23) = "Unknown"
                  End Select
               Case "CSDVersion"
                  vntRtnData(0, 24) = "SP Text"
                  vntRtnData(1, 24) = .Value
               Case "ServicePackMajorVersion"
                  vntRtnData(0, 25) = "SP, Major Ver"
                  vntRtnData(1, 25) = .Value
               Case "ServicePackMinorVersion"
                  vntRtnData(0, 26) = "SP, Minor Ver"
                  vntRtnData(1, 26) = .Value
               Case "SystemDrive"
                  vntRtnData(0, 27) = "System Drive"
                  vntRtnData(1, 27) = .Value
               Case "BootDevice"
                  vntRtnData(0, 28) = "Boot Device"
                  vntRtnData(1, 28) = .Value
               Case "SerialNumber"
                  vntRtnData(0, 29) = "Serial Number"
                  vntRtnData(1, 29) = .Value
               Case "CurrentTimeZone"
                  vntRtnData(0, 30) = "Minutes Offset GMT"
                  vntRtnData(1, 30) = .Value
               Case "EncryptionLevel"
                  vntRtnData(0, 31) = "Encryption Level"
                  vntRtnData(1, 31) = .Value
               Case "ForegroundApplicationBoost"
                  vntRtnData(0, 32) = "Foreground App Boost"
                  Select Case .Value
                     Case 0
                        vntRtnData(1, 32) = "None"
                     Case 1
                        vntRtnData(1, 32) = "Minimum"
                     Case 2
                        vntRtnData(1, 32) = "(Default) Maximum"
                  End Select
               Case Else
                  On Error Resume Next
                  ' Ignore the rest
                  Debug.Print .Name, .Value
            End Select
         End With
      Next
   Next

   GetOsData = vntRtnData
   
End Function

Private Function TransK(ByVal xi_vntRawNumber As Variant) As String
On Error Resume Next
   Dim p_dblFactor                     As Double
   Dim p_dblMegs                       As Double
   
   p_dblFactor = 1024#
   p_dblMegs = CDbl(xi_vntRawNumber) / p_dblFactor
   
   TransK = Format$(CStr(p_dblMegs), "Standard")
   
End Function

Private Function TransPercent(ByVal xi_vntRawNumber As Variant) As String
On Error Resume Next
   
   TransPercent = Format$(xi_vntRawNumber, "Percent")
   
End Function

Private Function TransMeg(ByVal xi_vntRawNumber As Variant) As String
On Error Resume Next
   Dim p_dblFactor                     As Double
   Dim p_dblMegs                       As Double
   
   p_dblFactor = 1024# * 1024#
   p_dblMegs = CDbl(xi_vntRawNumber) / p_dblFactor
   
   TransMeg = Format$(CStr(p_dblMegs), "Standard")
   
End Function

Private Function TransTime(ByVal xi_vntRawNumber As Variant) As String
On Error Resume Next
   Dim p_strTmp                        As String
   
   p_strTmp = Trim$(Format$(xi_vntRawNumber, "Standard"))
   TransTime = Mid$(p_strTmp, 1, Len(p_strTmp) - 3)
   
End Function

Private Function TransNum(ByVal xi_vntRawNumber As Variant) As String
On Error Resume Next
   Dim p_strTmp                        As String
   
   p_strTmp = Trim$(Format$(xi_vntRawNumber, "Standard"))
   TransNum = Mid$(p_strTmp, 1, Len(p_strTmp) - 3)
   
End Function

Private Function TransSoftwareDate(ByVal xi_strUntranslatedDate As String) As String
On Error Resume Next

   TransSoftwareDate = CStr(DateSerial(Left$(xi_strUntranslatedDate, 4), _
                                       Mid$(xi_strUntranslatedDate, 5, 2), _
                                       Mid$(xi_strUntranslatedDate, 7, 2)))
                                       
End Function

Private Function TransDate(ByVal xi_strUntranslatedDate As String) As String
On Error Resume Next
   
   TransDate = CStr(DateSerial(Left$(xi_strUntranslatedDate, 4), _
                               Mid$(xi_strUntranslatedDate, 5, 2), _
                               Mid$(xi_strUntranslatedDate, 7, 2))) _
               & " -- " & _
               CStr(TimeSerial(Mid$(xi_strUntranslatedDate, 9, 2), _
                               Mid$(xi_strUntranslatedDate, 11, 2), _
                               Mid$(xi_strUntranslatedDate, 13, 2)))
                                  
End Function
